Unit AEE0R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMA1R_p;

procedure AEE0R(var A :Array of Real; var B :Array of Real;
                N :Integer; var P :Array of Integer; K :Integer;
                var RU :Array of Real; var W :Array of Real);

implementation

procedure AEE0R(var A :Array of Real; var B :Array of Real;
                N :Integer; var P :Array of Integer; K :Integer;
                var RU :Array of Real; var W :Array of Real);
var
I,J,D,E,F,G,H,U,H1,I1,P1 :Integer;
M,O,Q,R,S,X,BA,BB,WMIN2,HM :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
WMIN2 := SYS051;
W[0] := A[0];
if ( N = 1 ) 
 then goto _14;
AMA1R(A,B,N,M,O,HM,P1);
H := K;
for I:=1 to H do
 begin
  W[I-1] := M;
_1:
  RU[I-1] := O;
 end;
R := EMax1(Abs(O),Abs(M))*WMIN2;
S := 2.0*WMIN2;
H1 := 1+H;
for I1:=1 to H do
 begin
  D := H1-I1;
  M := W[D-1];
  if ( O > RU[D-1] ) 
   then O := RU[D-1];
  U := D+1;
  for E:=1 to D do
   begin
    I := U-E;
    if ( M >= W[I-1] ) 
     then goto _2;
    M := W[I-1];
    goto _3;
_2:
   end;
_3:
  Q := (M+O)*0.5;
  if ( O-M <= (Abs(O)+Abs(M))*S+R ) 
   then goto _11;
  F := 0;
  BA := A[0]-Q;
  if ( BA < 0.0 ) 
   then F := 1;
  for J:=2 to N do
   begin
    X := B[J-1];
    if ( BA <> 0.0 ) 
     then goto _4;
    BB := Abs(X)/WMIN2;
    goto _5;
_4:
    BB := (X/BA)*X;
_5:
    BA := A[J-1]-Q-BB;
    if ( BA < 0.0 ) 
     then F := F+1;
_6:
   end;
  if ( F >= P[D-1] ) 
   then goto _10;
  M := Q;
  if ( F >= P[0] ) 
   then goto _7;
  W[0] := Q;
  goto _3;
_7:
  for E:=1 to D do
   begin
    I := U-E;
    if ( P[I-1] > F ) 
     then goto _8;
    G := I+1;
    goto _9;
_8:
   end;
_9:
  W[G-1] := Q;
  if ( RU[I-1] > Q ) 
   then RU[I-1] := Q;
  goto _3;
_10:
  O := Q;
  goto _3;
_11:
  W[D-1] := Q;
_12:
 end;
if ( P1 = 0 ) 
 then goto _14;
HM := 1.0/HM;
for I:=1 to H do
 begin
_13:
  W[I-1] := W[I-1]*HM;
 end;
_14:
end;

end.
